!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine AsselinTimeFilter
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: asselintimefilter.f90,v 1.3 2005/10/19 05:46:35 odakker Exp $
!   * Tag Name: $Name: arare3-20051019 $
!   * Change History: 
!
!== Overview
!
! åλ֥ե륿. leap-frog θŬ. 
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!
                                                                 !=end

subroutine AsselinTimeFilter(var_a, var_n, var_b)
                                                                 !=begin
  !== Dependency
  use gridset,   only: DimXMin, DimXMax, DimZMin, DimZMax
  use arareset,  only: tfil
                                                                 !=end
  !--- ۤηػ
  implicit none
                                                                 !=begin  
  !== Input
  real(8), intent(in)     :: var_a(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)     :: var_b(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end
                                                                 !=begin
  !== In/Out
  real(8), intent(inout)  :: var_n(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end

  real(8) :: vartfil_n(DimXMin:DimXMax, DimZMin:DimZMax)
  

  !--- ֥ե륿
  vartfil_n = var_n + tfil * ( var_b  - 2.0d0 * var_n + var_a ) 

  !--- ե륿򤫤ѿ
  var_n = vartfil_n
  
end subroutine AsselinTimeFilter
